#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include "HSH.h"

/*A simple example program showing how to use the implementation and testing it*/
int main(int argc, char **argv)
{
	//Setup HSH for operations
	HSHContext context;
	HSHInit(&context);

	//Should we run a test?
	if(argc == 2 && strcmp(argv[1], "--test") == 0)
	{
		//Feed HSH with our test vector
		HSHStrInput(&context, "Yvonne");
		//Verify the test vector
		if(context.result == 0x923F2DB7)
		{
			printf("Test completed successfully.\n");
			return 0;
		}else{
			printf("Test failed.\n");
			return 1;
		}
	}else{
		//Print a message
		printf("Write message to be hashed with HSH 11/13:\n");

		//Read string from stdin
		char* value = NULL;
		char temp;
		int i = 0;
		while(1)
		{
			temp = getchar();
			if(temp == '\n' || temp == EOF)
				break;
			value = (char*) realloc(value, i + 1);
			value[i] = temp;
			i++;
		}
		value[i] = '\0';

		//If reading didn't end with a newline write one
		if(temp != '\n')
			printf("\n");

		//Calculate hash of value
		HSHStrInput(&context, value);

		//Get the result:
		uint32_t result;
		HSHResult(&context, &result);

		//Print result as hexadecimal
		printf("HSH 12/13 result: %02X\n", result);

		//Reset HSHContext, in case you wanted to do more hashing
		HSHReset(&context);
	}
	//Assume everything went well
	return 0;
}

